static int8_t  gDutyCycle = 49;


void setup ()
{
    Serial.begin(19200);
    while (!Serial);

    // Set the PWM output pin as an output
    DDRD |= _BV(PD5);     // PD5, OC0B, arduino pin 5

    // Make sure Timer/Counter0 is enabled at the power
    // saving register (on ATmega RESET, it is).
    //PRR &= ~_BV(PRTIM0);
    // Set the TOP value for TCNT0.
    OCR0A = 99;
    // Set the (initial) duty cycle. 0 to 99 will be 1 to 100%, 0% is a special
    // case handled separately by disabling PWM and setting the pin to 0.
    OCR0B = gDutyCycle;
    // Configure the mode, how the output pins change, and the prescaler.
    //   WGM0[2:0] = 111b = 7     Fast PWM Mode
    //   COM0B[1:0] = 10b = 2     set OC0B at BOTTOM, clear at OCR0A (compare match)
    //   CS0[2:0] = 001b = 1      TC0 clock prescaler = 1
    // The prescaler is used to enable the counter (make it start counting and beautiful
    // things happening).
    TCCR0A = 0
        | _BV(WGM01) | _BV(WGM00)   // fast PWM mode
        | _BV(COM0B1)   // set OC0B at BOTTOM, clear at OCR0A (compare match)
        ; 
    TCCR0B = 0
        | _BV(WGM02)    // fast PWM mode
        | _BV(CS00)     // prescaler = 1; this also enables the counter
        ;
}


static void SetDutyCycle (int8_t duty_in_percent)
{
    if (duty_in_percent == 0)
    {
        // The only way to get a permanent 0 at the pin is to force
        // the pin to 0. That's just how it works.
        PORTD &= ~_BV(PD5);
        TCCR0A &= ~(_BV(COM0B1) | _BV(COM0B0));
        return;
    }
    OCR0B = duty_in_percent - 1;
    TCCR0A |= _BV(COM0B1);
}


void loop ()
{
    if (Serial.available())
    {
        int  ch = Serial.read();
        switch (ch)
        {
            case '-' :
                gDutyCycle--;
                break;

            case '+' :
                gDutyCycle++;
                break;
        }

        gDutyCycle = constrain(gDutyCycle, 0, 100);
        Serial.print(gDutyCycle);
        Serial.println("%");
        SetDutyCycle(gDutyCycle);
    }
}

